<?php

namespace HCM\FPA\ObrigacaoLegal\Manad\Blocos\Registros;

use HCM\FPA\Registro\FPARegistro;

class Registro0000 extends FPARegistro {
    
    const REGISTRO_0000 = '0000';
    const REGISTRO_0001 = '0001';
    const REGISTRO_0050 = '0050';
    const REGISTRO_0100 = '0100';
    const REGISTRO_0990 = '0990';
    const REGISTRO_I001 = 'I001';
    const REGISTRO_I990 = 'I990';
    const REGISTRO_K001 = 'K001';
    const REGISTRO_K050 = 'K050';
    const REGISTRO_K100 = 'K100';
    const REGISTRO_K150 = 'K150';
    const REGISTRO_K250 = 'K250';
    const REGISTRO_K300 = 'K300';
    const REGISTRO_K990 = 'K990';
    const REGISTRO_L001 = 'L001';
    const REGISTRO_L990 = 'L990';
    const REGISTRO_9001 = '9001';
    const REGISTRO_9900 = '9900';
    const REGISTRO_9990 = '9990';
    const REGISTRO_9999 = '9999';
    const EMAIL = 'E';

    private $_nome;
    private $_cnpj;
    private $_cpf;
    private $_cei;
    private $_nit;
    private $_uf;
    private $_ie;
    private $_codMun;
    private $_im;
    private $_suframa;
    private $_indCentr;
    private $_dtIni;
    private $_dtFim;
    private $_codVer = '003'; //Código de Versão de Leiaute do MANAD. 003-Instrução Normativa MPS/SRP nº. 12/2006. Versão do leiaute Nº. 1.0.0.2
    private $_codFin;
    private $_indEd = 2; //Indicador de tipo de entrada de dados. 2-Validação de arquivo texto (arquivo gerado diretamente por sistema informatizado, já no leiaute requerido)

    public function geraRegistro($tpRegistro, $tpInscricao=null, $nrInscricao=null){
        $this->_geraRegistro(self::REGISTRO_0000);
    }

    public function geraRegistro0000(){
        $this->_geraRegistro(self::REGISTRO_0000);
    }

    private function _geraRegistro($tpRegistro){
        // Ordem 1
        $this->atribuiDadoManad($tpRegistro);
        // Ordem 2
        $this->atribuiDadoManad($this->_nome);
        // Ordem 3
        $this->atribuiDadoManad($this->_cnpj);
        // Ordem 4
        $this->atribuiDadoManad($this->_cpf);
        // Ordem 5
        $this->atribuiDadoManad($this->_cei);
        // Ordem 6
        $this->atribuiDadoManad($this->_nit);
        // Ordem 7
        $this->atribuiDadoManad($this->_uf);
        // Ordem 8
        $this->atribuiDadoManad($this->_ie);
        // Ordem 9
        $this->atribuiDadoManad($this->_codMun);
        // Ordem 10
        $this->atribuiDadoManad($this->_im);
        // Ordem 11
        $this->atribuiDadoManad($this->_suframa);
        // Ordem 12
        $this->atribuiDadoManad($this->_indCentr);
        // Ordem 13
        $this->atribuiDadoManad($this->_dtIni);
        // Ordem 14
        $this->atribuiDadoManad($this->_dtFim);
        // Ordem 15
        $this->atribuiDadoManad($this->_codVer);
        // Ordem 16
        $this->atribuiDadoManad($this->_codFin);
        // Ordem 17
        $this->atribuiDadoManad($this->_indEd, true);
    }
    
    public function setNome($nome){
        $this->_nome = $nome;
    }
    public function setCnpj($cnpj){
        $this->_cnpj = $cnpj;
    }
    public function setCpf($cpf){
        $this->_cpf = $cpf;
    }
    public function setCei($cei){
        $this->_cei = $cei;
    }
    public function setNit($nit){
        $this->_nit = $nit;
    }
    public function setUf($uf){
        $this->_uf = $uf;
    }
    public function setIe($ie){
        $this->_ie = $ie;
    }
    public function setCodMun($codMun){
        $this->_codMun = $codMun;
    }
    public function setIm($im){
        $this->_im = $im;
    }
    public function setSuframa($suframa){
        $this->_suframa = $suframa;
    }
    public function setIndCentr($indCentr){
        $this->_indCentr = $indCentr;
    }
    public function setDtIni($dtIni){
        $this->_dtIni = $dtIni;
    }
    public function setDtFim($dtFim){
        $this->_dtFim = $dtFim;
    }
    public function setCodVer($codVer){
        $this->_codVer = $codVer;
    }
    public function setCodFin($codFin){
        $this->_codFin = $codFin;
    }
    public function setIndEd($indEd){
        $this->_indEd = $indEd;
    }
}