<?php

namespace HCM\Geral\Controllers;

use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request;
use HCM\Geral\Services\EnviarEmailService;
use HCM\Geral\Services\EnviarMensagemService;
use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;

class EnviarMensagemController extends Crud {

    public function __construct (HCMParameters $hcmParameters,  EnviarEmailService $enviarEmailService, EnviarMensagemService $enviarMensagemService, EntityManager $entityManager){
        $this->hcmParameters   = $hcmParameters;
        $this->enviarEmailService = $enviarEmailService;
        $this->enviarMensagemService = $enviarMensagemService;
        $this->entityManager = $entityManager;
    }

    public function enviarMensagem (DTO\Request\DataSet $request, DTO\Response $response) {
        try{
            foreach ($request->getDataSet()->getRows() as $row) {
                if(array_key_exists('CANDIDATOS', $row)){
                    foreach ($row['CANDIDATOS'] as $candidato) {    
                        $nrorg = $this->hcmParameters->getNrorgPadrao();
                        if(array_key_exists('NRPARCNEGOCIOCAND', $candidato)){
                            $nrparcnegocio = $candidato["NRPARCNEGOCIOCAND"];
                        } else {
                            $nrparcnegocio = $candidato["NRPARCNEGOCIO"];
                        }
                        $result = $this->enviarMensagemService->getOperadorParcnegocio($nrorg, $nrparcnegocio);
                        $nmoperador = $result['NMOPERADOR'];
                        $dsemailoper = $result['DSEMAILOPER'];

                        $nrorgEstru = $this->hcmParameters->getNrorgTrabalho();
                        $nrprocesso = $row['PROCESSO']['NRPROCESSO'];
                        $result = $this->enviarMensagemService->getEstruturaProcesso($nrorgEstru, $nrprocesso);
                        $nmestruturam = $result['NMFANTASIA'];
                        $nmprocesso = $result['NMPROCESSO'];

                        $array = array(
                            "[NOME_CANDIDATO]" => $nmoperador, "[NOME_PROCESSO]" => $nmprocesso, "[ESTRUTURA_PROCESSO]" => $nmestruturam
                        );
                        $row['MENSAGEM']['DSMENSAGEM'] = strtr($row['MENSAGEM']['DSMENSAGEM'], $array);
                        $title = 'Alerta de Vagas';
                        $subject = $row['MENSAGEM']['DSTITULOMENSAGEM'];
                        $content = $row['MENSAGEM']['DSMENSAGEM'];
                        $headerContent = 'Olá'.' '.$nmoperador;
                        $footerContent = null;
                        $footerTemplate = 'Você está recebendo este email por estar relacionado à uma vaga do Portal de Talentos.';
                        $nmfrom = 'RH Teknisa';
                        $ignoreContentDefault = true;
                        $from = $row['MENSAGEM']['DSEMAILOPERLOG'];
                        $this->enviarEmailService->enviarEmailAlerta($title, $dsemailoper, $nmoperador, $nmestruturam, $subject, $content, $headerContent, $footerContent, $footerTemplate, $nmfrom, $from, $ignoreContentDefault);
                        $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('enviarMensagem', array(true)));
                    }
                } else if(array_key_exists('COMUNICADO', $row)){
                    $nrorg = $row['COMUNICADO']['NRORGRELACIONADA'];
                    $nrparcnegocio = $row['COMUNICADO']["NRPARCNEGOCIORELA"];
                    $result = $this->enviarMensagemService->getOperadorParcnegocio($nrorg, $nrparcnegocio);
                    $nmoperador = $result['NMOPERADOR'];
                    $dsemailoper = $result['DSEMAILOPER'];

                    $nmestruturam = 'teknisa';
                    $array = array(
                        "[NOME_CANDIDATO]" => $nmoperador, "[NOME_EVENTO]" => $row['COMUNICADO']['NMEVENTO'], "[LOCAL_EVENTO]" => $row['COMUNICADO']['DSLOCAL'], "[DATA_EVENTO]" => $row['COMUNICADO']['DTEVENTO'], "[RESPONSAVEL_EVENTO]" => $row['COMUNICADO']['NMPARCNEGOCIORESP'], "[DESCRICAO_EVENTO]" => $row['COMUNICADO']['DSEVENTO']
                    );
                    $row['MENSAGEM']['DSMENSAGEM'] = strtr($row['MENSAGEM']['DSMENSAGEM'], $array);
                    $title = 'Alerta de Vagas';
                    $subject = $row['MENSAGEM']['DSTITULOMENSAGEM'];
                    $content = $row['MENSAGEM']['DSMENSAGEM'];
                    $headerContent = 'Olá'.' '.$nmoperador;
                    $footerContent = null;
                    $footerTemplate = 'Você está recebendo este email por estar relacionado à uma vaga do Portal de Talentos.';
                    $nmfrom = 'RH Teknisa';
                    $from = $row['MENSAGEM']['DSEMAILOPERLOG'];
                    $ignoreContentDefault = true;
                    $this->enviarEmailService->enviarEmailAlerta($title, $dsemailoper, $nmoperador, $nmestruturam, $subject, $content, $headerContent, $footerContent, $footerTemplate, $nmfrom, $from, $ignoreContentDefault);
                    $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('enviarMensagem', array(true)));
                } else if(array_key_exists('CANDIDATO', $row)) {
                    foreach ($row['CANDIDATO'] as $candidato) {
                        $nrorg = $this->hcmParameters->getNrorgPadrao();
                        if(array_key_exists('NRPARCNEGOCIOCAND', $candidato)){
                            $nrparcnegocio = $candidato["NRPARCNEGOCIOCAND"];
                        } else {
                            $nrparcnegocio = $candidato["NRPARCNEGOCIO"];
                        }

                        $result = $this->enviarMensagemService->getOperadorParcnegocio($nrorg, $nrparcnegocio);
                        $nmoperador = $result['NMOPERADOR'];
                        $dsemailoper = $result['DSEMAILOPER'];

                        if(array_key_exists('linkQuestionario', $candidato)){
                            $link = $candidato['linkQuestionario'];
                        } else {
                            $link = null;
                        }

                        if(array_key_exists('NMPROCESSO', $candidato)){
                            $nmprocesso = $candidato['NMPROCESSO'];
                        } else {
                            $nmprocesso = null;
                        }

                        if(array_key_exists('NMESTRUTURAM', $candidato)){
                            $nmestruturam = $candidato['NMESTRUTURAM'];
                        } else {
                            $nmestruturam = null;
                        }

                        $array = array(
                            "[NOME_CANDIDATO]"     => $nmoperador,
                            "[LINK_QUESTIONARIO]"  => $link,
                            "[NOME_PROCESSO]"      => $nmprocesso,
                            "[ESTRUTURA_PROCESSO]" => $nmestruturam
                        );
                        $row['MENSAGEM']['DSMENSAGEM'] = strtr($row['MENSAGEM']['DSMENSAGEM'], $array);
                        $title = 'Alerta de Vagas';
                        $subject = $row['MENSAGEM']['DSTITULOMENSAGEM'];
                        $content = $row['MENSAGEM']['DSMENSAGEM'];
                        $headerContent = 'Olá Nome do Candidato';
                        $footerContent = null;
                        $footerTemplate = 'Você está recebendo este email por estar relacionado à uma vaga do Portal de Talentos.';
                        $nmfrom = 'RH Teknisa';
                        $ignoreContentDefault = true;
                        $from = $row['MENSAGEM']['DSEMAILOPERLOG'];
                        $this->enviarEmailService->enviarEmailAlerta($title, $dsemailoper, $nmoperador, 'teknisa', $subject, $content, $headerContent, $footerContent, $footerTemplate, $nmfrom, $from, $ignoreContentDefault);
                        $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('enviarMensagem', array(true)));
                    }
                } else {
                    if(array_key_exists('NRORG', $row)){
                        $nrorg = $row['NRORG'];
                    } else {
                        $nrorg = $row[0]['NRORG'];
                    }
                    if(array_key_exists('CDOPERADOR_LOG', $row)){
                        $cdoperador = $row['CDOPERADOR_LOG'];
                    } else {
                        $cdoperador = $row[0]['CDOPERADOR_LOG'];
                    }

                    $result = $this->enviarMensagemService->getOperador($nrorg, $cdoperador);
                    $nmoperador = $result['NMOPERADOR'];
                    $dsemailoper = $result['DSEMAILOPER'];
                    
                    $array = array(
                        "[NOME_CANDIDATO]" => 'Nome do Candidato', "[NOME_PROCESSO]" => 'Nome do Processo', "[ESTRUTURA_PROCESSO]" => 'Nome da Empresa'
                    );
                    $row['MENSAGEM']['DSMENSAGEM'] = strtr($row['MENSAGEM']['DSMENSAGEM'], $array);
                    $title = 'Alerta de Vagas';
                    $subject = $row['MENSAGEM']['DSTITULOMENSAGEM'];
                    $content = $row['MENSAGEM']['DSMENSAGEM'];
                    $headerContent = 'Olá Nome do Candidato';
                    $footerContent = null;
                    $footerTemplate = 'Você está recebendo este email por estar relacionado à uma vaga do Portal de Talentos.';
                    $nmfrom = 'RH Teknisa';
                    $ignoreContentDefault = true;
                    $from = $row['MENSAGEM']['DSEMAILOPERLOG'];
                    $this->enviarEmailService->enviarEmailAlerta($title, $dsemailoper, 'Nome do Candidato', 'teknisa', $subject, $content, $headerContent, $footerContent, $footerTemplate, $nmfrom, $from, $ignoreContentDefault);
                    $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('enviarMensagem', array(true)));
                }
            }
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }

    public function enviarEmailDemonstrativo($row, $nrorg, $mesCompetencia, $nrvinculom, $nrestruturalegal, $anexo, $estruturaG = NULL, $validaEmailTabelaOper = NULL){
        if( (gettype($nrorg)=='NULL') && (gettype($nrvinculom)=='NULL') ){
            $nmoperador = $estruturaG['nome'];
            $dsemailoper = $estruturaG['email'];            
        }else{
            $result = $this->enviarMensagemService->getOperadorVinculo($nrorg, $nrvinculom);
            if (!$result) {
                return 'AMBOS';
            } else {
                if (is_null($result['DSEMAILOPER'])) {
                    return 'DSEMAILOPER';
                }
            }
            $nmoperador = $result['NMOPERADOR'];
            $dsemailoper = $result['DSEMAILOPER'];
            /*if($validaEmailTabelaOper == 'validaEmailExistente'){
                $sql = "SELECT NMOPERADOR
                        FROM OPERADOR
                        WHERE (DSEMAILOPER = '$dsemailoper')";
    
                $std = $this->entityManager->getConnection()->prepare($sql);
                $std->execute();
                $result = $std->fetchAll();
    
                if (empty($result)) {
                    return 'Email do operador '.$nmoperador.' não existente.';
                }
            }*/
        }
        
        $replaceMnemonico = array(
            "[COMPETENCIA]" => substr($mesCompetencia, 3), 
            "[COLABORADOR]" => $nmoperador
        );

        $row['DSMENSAGEM'] = strtr($row['DSMENSAGEM'], $replaceMnemonico);
        $subject = $row['DSTITULOMENSAGEM'] = strtr($row['DSTITULOMENSAGEM'], $replaceMnemonico);

        $content = array(
            "SUBJECT"                 => $subject,
            "STRING_SUPERIOR_DIREITA" => "",
            "CONTENT_BODY"            => $row['DSMENSAGEM']
        );

        if (!isset($row['DSEMAILOPERLOG']))
            $row['DSEMAILOPERLOG'] = $dsemailoper;

        $nmremetente = 'Departamento Pessoal';
        $this->enviarEmailService->enviarEmailPersonalizado('TEKNISA', $dsemailoper, $subject, $nmoperador, $nmremetente, $nrestruturalegal, $content, $row['DSEMAILOPERLOG'], $anexo, $validaEmailTabelaOper);

        return true;
    }
    
     public function enviarEmail($row, $nrorg, $mesCompetencia, $nrparcnegocio){
        $result = $this->enviarMensagemService->getOperadorParcnegocio($nrorg, $nrparcnegocio); 
       if (!$result) {
            return 'AMBOS';
        } else {
            if (is_null($result['DSEMAILOPER'])) {
                return 'DSEMAILOPER';
            }
        }        

        $nmoperador = $result['NMOPERADOR'];
        $dsemailoper = $result['DSEMAILOPER'];

        $subject = $row['DSTITULOMENSAGEM'];
        
        $content = array(
            "SUBJECT"                 => $subject,
            "STRING_SUPERIOR_DIREITA" => "",
            "CONTENT_BODY"            => $row['DSMENSAGEM']
        );

        if (!isset($row['DSEMAILOPERLOG']))
            $row['DSEMAILOPERLOG'] = $dsemailoper;

        $nmremetente = $this->hcmParameters->getNmoperador();
        $this->enviarEmailService->enviarEmailPersonalizado('TEKNISA', $dsemailoper, $subject, $nmoperador, $nmremetente, null, $content, $row['DSEMAILOPERLOG']);

        return true;
    }
}