/* Sistemas Integrados TECNISA
   Planejamento Alimentao Industrial

Nome: GERA_DATA.SQL

Descrio:
Insere datas em determinado perodo na tabela DATA.

P_DTINICIAL - Data inicial
P_DTFINAL   - Data final

Criao:
11/12/98 - Ederson
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE 
	        O.NAME = 'GERA_DATA'  AND 
	        TYPE = 'P' 			        AND
	        U.UID = O.UID             		        AND 
	        U.NAME = USER)
  DROP PROCEDURE GERA_DATA
  GO

CREATE PROCEDURE GERA_DATA
                           @P_DTINICIAL DATETIME,
   			   @P_DTFINAL   DATETIME

AS

   DECLARE @V_DTAUXILIAR DATETIME;
   DECLARE @V_CONTAUXI   NUMERIC;

BEGIN

   IF @P_DTFINAL < @P_DTINICIAL
   BEGIN
      /*raise_application_error(-20501, 'Data final deve ser maior ou igual a data inicial.', True);*/
      RAISERROR('Data final deve ser maior ou igual a data inicial.', 16,1);
   END;

   SET @V_DTAUXILIAR = @P_DTINICIAL;
   WHILE (@V_DTAUXILIAR <= @P_DTFINAL)
   BEGIN

       SELECT @V_CONTAUXI = COUNT(*)
       FROM DATA
       WHERE (DTDATA = @V_DTAUXILIAR);

       IF @V_CONTAUXI = 0
       BEGIN
          INSERT INTO
          DATA (DTDATA)
          VALUES (@V_DTAUXILIAR);
       END;

       SET @V_DTAUXILIAR = @V_DTAUXILIAR + 1;
   END;
                                   
   UPDATE DATA
   SET DTMES = DTDATA - DAY(DTDATA) + 1
   WHERE
     DTMES IS NULL;

  --COMMIT;
END;
GO

BEGIN
   DECLARE @DT DATETIME;
   DECLARE @DT1 DATETIME;
   SET DATEFORMAT DMY;
   SET @DT = CONVERT(DATETIME, '01/01/1900');
   SET @DT1 = CONVERT(DATETIME, '31/12/2020');
   
   EXEC GERA_DATA @DT,@DT1;
END;
GO
